/**************************************************
 *
 *   Contains the vocabulary and responses of
 *   Adventures on Planet Smir III, 1
 *
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <errno.h>
#include <ctype.h>

#include "aconst.h"
#include "words.h"
#include "rooms.h"
#include "player.h"

//Compression using the printtok() function:
//------------------------------------------
//Note that you can compress all the strings in this file except for noun and verb names.
//If desired, the printtok() function can be used to print text compressed using the
//techniques described in the "printtok-002.c" file.  If not, the manual describes
//how to disable text compression.  Then, the modules here will redirect output
//printtok() to prints() instead.  prints() is the print string function from
//the CBMSimpleIO and AtaSimpleIO libraries.
/*************************************
	Items
 *************************************/

//If compiling for a 32k cartridge, place word definitions in second 16k.
#ifdef __DOFE3__
#pragma rodata-name ("RODATA2")
#pragma data-name ("DATA2")
#endif

//The actual items.  Each entry is the name of the item followed by the
//help given when the user types "look <item>."
///If 0, no help will be displayed.
struct item_ Item []={
/* Item 0 */
	{"key",
		"Description of key."}
};

//Verb names folowed by the address of the verb-handling routine.
//If you need more verbs, increase the definition of NumVerbs in the
//file "aconst.h" to the # verbs you need.
struct verb_ Verb[] ={
	{"look",	&vLook},
	{"go",		&vGo},
	{"get",		&vGet},
	{"grab",	&vGet},
	{"take",	&vGet},
	{"put",		&vPut},
	{"place",	&vPut},
	{"drop",	&vPut},
	{"inventory",	&vItems},
	{"i",		&vItems},

	{"intro",	&vIntro},
	{"help",	&vHelp},
	{"read",	&vRead},
	
	{"score",	&vScore},

	{"n",		&vGoNorth},
	{"s",		&vGoSouth},
	{"e",		&vGoEast},
	{"w",		&vGoWest}
};

//Contains the help/intro pages displayed when
//the user types "intro."
//Add your program concept and
//instructions here.
//You can add more pages here, but you need to increase the number here and in
//the vIntro() function contained in the "words.c" file and add lines to
//vIntro() to display the extra pages.
const char* HelpPages[2] =
{
	"Help Page 1\n"
	
	"Press any key..."
,
	"Help page 2\n"

};

